Dim objTable, objFS, objFile, objTableName, bMissingTableMDB, objMDB,oLogFile, strFolder, nIndex, oTSMergeSetupFile, sLine, i, j, Folder_name, colFiles, bFound
Dim aTables(), aDatabase()

strFolder="%PATH_MERGE_TOOL%"

On Error Resume Next
Set objFS = CreateObject("Scripting.FileSystemObject")  
'Set appAccess = WScript.CreateObject("Access.Application")
'appAccess.Visible = False

'Read merge setup file to retrive table name for external file
If objFS.FileExists(strFolder & "Temp\" & "MERGE_SETUP.TXT") Then
		Set oTSMergeSetupFile = objFS.OpenTextFile(strFolder & "Temp\" & "MERGE_SETUP.TXT", 1)  ' 1 = IOMode.ForReading
Else
		MsgBox "...Temp\MERGE_SETUP.TXT file does not exist!",16 
		Set objFS = Nothing
		Wscript.Quit
End If

'oTSMergeSetupFile.Open

ReDim aTables(1)
i=0
Do While Not oTSMergeSetupFile.AtEndOfStream       
    sLine = Split(oTSMergeSetupFile.ReadLine(), "|")    
    aTables(i)=Trim(sLine(2))
    i=i+1  
    ReDim Preserve aTables(i) 
Loop


'************************************************************************************************
'Check for missing table, defined in the merge setup file, in the Master database
'Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\LOG_MASTER_MISSING_TABLE.txt", True)
'************************************************************************************************

'Check the log file for master database missing tables
'if found then delete the log file

If objFS.FileExists(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt") Then
		Set objFile=objFS.GetFile(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt")
		objFile.Delete()
End If


If objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") Then
		Set objFile=objFS.GetFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt")
		objFile.Delete()
End If

bFound=False
bMissingTableMDB=False

'Read the master database
Set appAccess = WScript.CreateObject("Access.Application")
appAccess.Visible = False
appAccess.OpenCurrentDatabase ("%PATH_MASTER_DATABASE%")
'Read all tables in the master database
Set objTable = appAccess.CurrentData.AllTables

For i=0 to UBound(aTables) - 1

		For each objTableName In objTable
				If aTables(i) = objTableName.Name Then
						bFound=True
						Exit For		
				End If		
		Next
		
		If Not objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") and not bFound Then
				Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt", True)
				oLogFile.WriteLine("")
				oLogFile.WriteLine("Missing master database table information" & ", " & "Date & Time :" & Now())
				oLogFile.WriteLine("==================================================================================")				
		End If
		
		If not bFound Then
				oLogFile.WriteLine("Database Name :%PATH_MASTER_DATABASE%" & ", " & "Missing table name :" & aTables(i))
				bMissingTableMDB=True
		Else
				bFound=False		
		End If				
		
Next

'Close currently open database
appAccess.CloseCurrentDatabase

'If master database does not have all the necessary tables then stop the merge process
If bMissingTableMDB=True Then
		MsgBox "Master database does not have all necessary tables to perform merge process!  Please check the log file for detail information, ...\Temp\LOG_MASTER_MISSING_TABLE.txt",16,"Missing table in the master database"
		WScript.Quit
End If
'*************************************************************************************************


'Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt", True) 

ReDim aDatabase(1)		
j=0
bFound=False
bMissingTableMDB=False
Set Folder_name = objFS.GetFolder("%PATH_MERGE_UNZIP_FILES%")  
Set colFiles = Folder_name.Files 

'Delete missing table log file
'If objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") Then
'		Set objFile=objFS.GetFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt")
'		objFile.Delete()
'End If

For each objMDB In colFiles
			
		'Read the database
		appAccess.OpenCurrentDatabase (objMDB)
'		MsgBox Err.Description
		'Read all tables from master database
		Set objTable = appAccess.CurrentData.AllTables
		
		For i=0 to UBound(aTables) - 1
		
				For each objTableName In objTable
						If aTables(i) = objTableName.Name Then
								bFound=True
								Exit For		
						End If		
				Next

				If Not objFS.FileExists(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt") and not bFound Then
						Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\LOGFILE_MISSING_TABLE.txt", True) 
						oLogFile.WriteLine("")
						oLogFile.WriteLine("Date & Time :" & Now())			
						oLogFile.WriteLine("Below is a list of databases that have not been processed due to missing tables, and moved to the folder [...\Temp\Missing_table_database\].")
						oLogFile.WriteLine("===============================================================================")		
						oLogFile.clsoe	
				End If	

				If Not objFS.FileExists(strFolder & "Temp" & "\MERGE_LOGFILE.txt") and not bFound Then
						Set oLogFile = objFS.CreateTextFile(strFolder & "Temp" & "\MERGE_LOGFILE.txt", True) 
						oLogFile.WriteLine("")
						oLogFile.WriteLine("Date :" & Now())			
						oLogFile.WriteLine("Below is a list of databases that have not been processed due to missing tables, and moved to the folder [...\Temp\Missing_table_database\].")
						oLogFile.WriteLine("===============================================================================")			
				End If			
								
				If not bFound Then
						oLogFile.WriteLine("Database Name :" & objMDB.Name & ", " & "Missing table name :" & aTables(i) )
						bMissingTableMDB=True
				Else
						bFound=False		
				End If				
				
		Next
			
		appAccess.CloseCurrentDatabase	
	
		If bMissingTableMDB Then
				aDatabase(j)=objMDB.Name
				j=j+1
				ReDim Preserve aDatabase(j)
				bMissingTableMDB=False
				oLogFile.WriteLine("==============================================================================")
		End If 
				
Next

For i=0 to UBound(aDatabase)-1
		'Move database with missing tables to the "...\Missing_table_database" folder
		Set objFile=objFS.GetFile("%PATH_MERGE_UNZIP_FILES%" & aDatabase(i))		
		objFile.Copy (strFolder & "Missing_table_database\" & aDatabase(i))
		objFile.Delete()
Next

oTSMergeSetupFile.Close
Set objMDB=Nothing
Set objFS = Nothing
Set objFile = Nothing
Set oTSMergeSetupFile = Nothing
Set oLogFile = Nothing
Set objTable = Nothing
Wscript.Quit
