Set objFS = CreateObject("Scripting.FileSystemObject")  
Dim oTSMergeSetupFile
strFolder="C:\MERGE_TOOL\"
Sub ReadSetupFile()
		'Read merge setup file to retrive table name for external file
		If objFS.FileExists(strFolder & "Temp\" & "MERGE_SETUP.TXT") Then
				Set oTSMergeSetupFile = objFS.OpenTextFile(strFolder & "Temp\" & "MERGE_SETUP.TXT", 1)  ' 1 = IOMode.ForReading
		Else
				MsgBox "...Temp\MERGE_SETUP.TXT file does not exist!",16 
				Set objFS = Nothing
				Wscript.Quit
		End If
End Sub

'Count number of lines in the setup file for redefine the array elements
i=0
Call ReadSetupFile	'call the sub for reading the setup file
'Count number of lines
Do While Not oTSMergeSetupFile.AtEndOfStream  
	sLine = oTSMergeSetupFile.ReadLine() 
	If Trim(sLine)="" Then
		Exit Do
	End If
	i = i+1
Loop
ReDim amTables(i,2)	'Redefine the array

oTSMergeSetupFile.Close	'Close open file

Call GetKeyFields

Sub GetKeyFields()

		Dim objSetupFile
		Dim strKeyFields
		Set objSetupFile = ReadSetupFile 'call the sub for reading the setup file
		i=0
		Do While Not objSetupFile.AtEndOfStream   
		    sLine = Split(objSetupFile.ReadLine(), "|")    
		    If Trim(sLine(0)) ="" Then
		    	Exit Do
		    End If
		    amTables(i,0)=Trim(sLine(0))	'Store master database name
		    amTables(i,1)=Trim(sLine(1))	'Store master table name
		    amTables(i,2)=Trim(sLine(2))	'Store external database name
		   
		    aFields(i) = Trim(sLine(3))		'Store Key fields variables name
		    i=i+1  
		Loop
		
		'Replace tab with space characters
		'Dim aKeyFields
		j=0
		Dim aFields()
		Remid aFields(1)
		For i = 0 to Ubound(aFields) - 1
			strKeyFields = Trim(Replace(aFields(i), vbTab, " "))
			strKeyFields = RemoveChars(strKeyFields)	'call remove characters function
			MsgBox strKeyFields
			aTemp = Split(strKeyFields,"And")					'Split variables
			For j=UBound(aFields)-1 to UBound(aTemp) - 1
					aFields(j) = aTemp(j)
					MsgBox aFields(j)
					ReDim Preserve aFields(j+1)					
			Next
		Next

End Sub

Function RemoveChars(KeyFields)
		' Filter all specified characters from the string
		Const CHARS = "()"
		For i = 1 to Len(CHARS)
			RemoveChars = Trim(Replace(KeyFields, Mid(CHARS, i,1)," "))
		Next
End Function









